Index: branches/encoders/code/behaviors/spline/slave/slave.c
===================================================================
--- branches/encoders/code/behaviors/spline/slave/slave.c	(revision 1344)
+++ branches/encoders/code/behaviors/spline/slave/slave.c	(revision 1345)
@@ -18,9 +18,12 @@
 volatile int left_ref;
 volatile int right_ref;
 
-volatile int left_old;
-volatile int right_old;
+volatile int left_err_old;
+volatile int right_err_old;
 
+volatile int left_vel_old = 0;
+volatile int right_vel_old = 0;
+
 volatile int left_i = 0;
 volatile int right_i = 0;
 
@@ -27,19 +30,24 @@
 volatile int left_u;
 volatile int right_u;
 
-volatile int left_vel = 0;
-volatile int right_vel = 0;
+volatile int left_vel;
+volatile int right_vel;
 
 #define PL	1
 #define DL	0.1
 #define IL	0.1
 
+/*
 #define PR	1.5
 #define DR	0.2
 #define IR	0.1
+*/
+#define PR	1
+#define DR	0.1
+#define IR	0.1
 
 
-#define INTERVAL	50
+#define INTERVAL	20
 
 /* receive motor speed from master: 
  * left_speed left_dir right_speed right_dir
@@ -50,10 +58,14 @@
 	if (type != MOTOR) return;
 	
 	left_ref = packet[0];
+	if (left_ref > 127)
+		left_ref -= 256;
 	right_ref = packet[1];
+	if (right_ref > 127)
+		right_ref -= 256;
 
-	sprintf(buf, "received: %d %d\n", left_ref, right_ref);
-	usb_puts(buf);
+//	sprintf(buf, "received: %d %d\n", left_ref, right_ref);
+//	usb_puts(buf);
 	//orb_set_color(GREEN);
 }
 
@@ -61,17 +73,25 @@
 	int left_err = left_ref - left_vel;
 	int right_err = right_ref - right_vel;
 	
-	left_err = left_vel == 2048 ? left_old : left_err;
-	right_err = right_vel == 2048 ? right_old : right_err;
+	if (!left_ref)
+		left_err = 0;
+	if (!right_ref)
+		right_err = 0;
+	
+//	left_err = left_vel == 2048 ? left_err_old : left_err;
+//	right_err = right_vel == 2048 ? right_err_old : right_err;
 
 	left_i += left_err;
-	left_u = (int)(PL*(float)left_err + DL*(float)(left_err - left_old) + IL*(float)left_i);
-	left_old = left_err;
+	left_u = (int)(PL*(float)left_err + DL*(float)(left_err - left_err_old) + IL*(float)left_i);
+	left_err_old = left_err;
 	
 	right_i += right_err;
-	right_u = (int)(PR*(float)right_err + DR*(float)(right_err - right_old) + IR*(float)right_i);
-	right_old = right_err;
+	right_u = (int)(PR*(float)right_err + DR*(float)(right_err - right_err_old) + IR*(float)right_i);
+	right_err_old = right_err;
 
+//	sprintf(buf, "u: %d %d\n", left_u, right_u);
+//	usb_puts(buf);
+	
 	if (left_u < 0) {
 		left_dir = 0;
 		left_u = -left_u;
@@ -91,6 +111,11 @@
 
 	left_u = left_u > 210 ? 210 : left_u;
 	right_u = right_u > 210 ? 210 : right_u;
+
+	if (!left_ref)
+		left_u = 0;
+	if (!right_ref)
+		right_u = 0;
 }
 
 int main (void) {
@@ -101,8 +126,7 @@
 	//usb_puts("xbee id ");
 	//usb_putc(wl_get_xbee_id());
 	wl_init();
-    left_ref = 20;
-	right_ref = 20;
+
 	wl_register_packet_group(&packetHandler);
 	//orb_set_color(RED);
 	//motor1_set(FORWARD,230);
@@ -109,34 +133,42 @@
 	//motor2_set(FORWARD,230);
 	
 	while (1) {
-		usb_puts("We Win\n");
-	    //left_vel = encoder_get_v(0);
-		//right_vel = encoder_get_v(1);
-		 delay_ms(1000);
-		//if (!(count % INTERVAL)) {
-		//	wl_send_global_packet(GROUP, ENCODER, encoder, 2, 0);
+		
+		left_vel = encoder_get_v(0);
+		right_vel = encoder_get_v(1);
+		// err handling
+		if (left_vel == 2048)
+			left_vel = left_vel_old;
+		else 
+			left_vel_old = left_vel;
+		
+		if (right_vel == 2048)
+			right_vel = right_vel_old;
+		else 
+			right_vel_old = right_vel;
+		
+		
+		if (!(count % INTERVAL)) {
+			wl_send_global_packet(GROUP, ENCODER, encoder, 2, 0);
 			encoder[0] = left_vel;
 			encoder[1] = right_vel;
-		
-		   // usb_puti(left_vel);
-		  //  sprintf(buf, "sent (%d): %d %d %d %d\n", count, left_vel, right_vel, encoder[0], encoder[1]);
-		   // usb_puts(buf);
-		   // usb_puti(encoder[0]);
-	  //  }
-		
+			//sprintf(buf, "sent (%d): %d %d %d %d\n", count, left_vel, right_vel, encoder[0], encoder[1]);
+			//usb_puts(buf);
+		}	
 
-		//ctrl();
+		ctrl();
 	
-	  //  if (!(count % INTERVAL))
-	  //  	wl_do();
+		if (!(count % INTERVAL))
+			wl_do();
 		
 //		sprintf(buf, "motor (%d): %d %d %d %d\n", count, left_dir, left_ref, right_dir, right_ref);
 //		usb_puts(buf);
 
-	    //motor1_set(left_dir, left_u);
-		//motor2_set(right_dir, right_u);
+		motor1_set(left_dir, left_u);
+		motor2_set(right_dir, right_u);
 		
 		count++;
-	    delay_ms(1000);
+//		delay_ms(100);
 	}
 }
+
Index: branches/encoders/code/behaviors/spline/slave/Makefile
===================================================================
--- branches/encoders/code/behaviors/spline/slave/Makefile	(revision 1344)
+++ branches/encoders/code/behaviors/spline/slave/Makefile	(revision 1345)
@@ -92,7 +92,7 @@
 # Optimization level, can be [0, 1, 2, 3, s].
 #     0 = turn off optimization. s = optimize for size.
 #     (Note: 3 is not always the best optimization level. See avr-libc FAQ.)
-OPT = s
+OPT = 0
 
 # Debugging format.
 #     Native formats for AVR-GCC's -g are dwarf-2 [default] or stabs.
Index: branches/encoders/code/behaviors/spline/master/master.c
===================================================================
--- branches/encoders/code/behaviors/spline/master/master.c	(revision 1344)
+++ branches/encoders/code/behaviors/spline/master/master.c	(revision 1345)
@@ -23,7 +23,6 @@
 PacketGroupHandler packetHandler = {GROUP, 0, 0, &packet_receive, 0};
 
 void packet_receive (char type, int source, char* packet, int length) {
-
 	if(type == ENCODER)
 	{ 
 		if(id == -1)
@@ -32,10 +31,7 @@
 			motor1_set(1, 200);
 		usb_putc(packet[0]);
 		usb_putc(packet[1]);
-//		usb_putc(packet[2]);
-//		usb_putc(packet[3]);
 	}                                  
-	
 }
 
 int main (void) {
@@ -55,9 +51,7 @@
 		lcd_puts("starting init");
 		data[0] = usb_getc(); 
 		data[1] = usb_getc();
-		//data[2] = usb_getc();
-		//data[3] = usb_getc();
-		
+
 		lcd_puts("Done with init\n");
 
 		wl_send_global_packet(GROUP, MOTOR, data, 2, 0);
@@ -67,19 +61,16 @@
 		wl_register_packet_group(&packetHandler);
 	}
 
-//	lcd_clear_screen();
-  while (1) {
-  if(position == SENDER)
-  {
-		data[0] = usb_getc(); 
-		data[1] = usb_getc();
-		//data[2] = usb_getc();
-		//data[3] = usb_getc();
-		wl_send_global_packet(GROUP, MOTOR, data, 2, 0);
-	}	
+	while (1) {
+		if(position == SENDER)
+		{
+			data[0] = usb_getc(); 
+			data[1] = usb_getc();
+			wl_send_global_packet(GROUP, MOTOR, data, 2, 0);
+		}        
 
-	  wl_do();
-  }
-  
+		wl_do();
+	}
+
 }
-                                                   
+
Index: branches/encoders/code/lib/include/libwireless/sensor_matrix.h
===================================================================
--- branches/encoders/code/lib/include/libwireless/sensor_matrix.h	(revision 1344)
+++ branches/encoders/code/lib/include/libwireless/sensor_matrix.h	(revision 1345)
@@ -1,4 +1,29 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
  * @file sensor_matrix.h
  * @brief Definitions for sensor matrices
  *
@@ -7,6 +32,10 @@
  * @author Brian Coltin, Colony Project, CMU Robotics Club
  **/
 
+#ifndef SENSOR_MATRIX_H
+#define SENSOR_MATRIX_H
+
+
 /**
  * @defgroup sensormatrix Sensor Matrix
  * @brief the robot sensor matrix
@@ -17,53 +46,56 @@
  * @{
  **/
 
+#define MAXIMUM_XBEE_ID		0x10
+#define READING_UNKNOWN		0xFF
+
 /**
  * @struct SensorMatrix
  *
  * A sensor matrix.
  **/
+//TODO: the order of member variables in this struct should be changed in case the compile packs the struct
+// In order to achieve the best packing, the variables should be listed in order of decreasing memory size.
+// Thus, pointers should be first, followed by int, followed by char.
 typedef struct
 {
 	/**
-	 * The size of the sensor matrix.
-	**/
-	unsigned int size;
-	/**
-	 * The matrix. Each row represents the readings of one
-	 * robot.
+	 * The number of robots in the token ring.
 	 **/
-	int** matrix;
+	int numJoined;
 	/**
 	 * The element representing a robot is true if that robot
 	 * is in the token ring and false otherwise.
 	 **/
-	int* joined;
+	unsigned char joined[MAXIMUM_XBEE_ID];
+
+	// on the bayboard, we don't include the matrix to save memory.
+#ifndef BAYBOARD
 	/**
-	 * The number of robots in the token ring.
+	 * The matrix. Each row represents the readings of one
+	 * robot.
 	 **/
-	int numJoined;
+	unsigned char matrix[MAXIMUM_XBEE_ID][MAXIMUM_XBEE_ID];
+#endif
 } SensorMatrix;
 
 /**@brief Create a sensor matrix **/
-SensorMatrix* sensor_matrix_create(void);
-/**@brief Destroy a sensor matrix **/
-void sensor_matrix_destroy(SensorMatrix* m);
-/**@brief Add a robot to a sensor matrix **/
-void sensor_matrix_add_robot(SensorMatrix* m, unsigned int id);
-/**@brief Remove a robot from a sensor matrix **/
-void sensor_matrix_remove_robot(SensorMatrix* m, unsigned int id);
+void sensor_matrix_create(void);
 /**@brief Set a reading in a sensor matrix **/
-void sensor_matrix_set_reading(SensorMatrix* m, int observer, int robot, int reading);
+void sensor_matrix_set_reading(int observer, int robot, int reading);
 /**@brief Get a reading in a sensor matrix **/
-int sensor_matrix_get_reading(SensorMatrix* m, int observer, int robot);
+int sensor_matrix_get_reading(int observer, int robot);
 /**@brief Set whether the robot is in the token ring **/
-void sensor_matrix_set_in_ring(SensorMatrix* m, int robot, int in);
+void sensor_matrix_set_in_ring(int robot, int in);
 /**@brief Get whether the robot is in the sensor ring **/
-int sensor_matrix_get_in_ring(SensorMatrix* m, int robot);
-/**@brief Get the size of the sensor matrix **/
-int sensor_matrix_get_size(SensorMatrix* m);
+int sensor_matrix_get_in_ring(int robot);
 /**@brief Get the number of robots which have joined the token ring **/
-int sensor_matrix_get_joined(SensorMatrix* m);
+int sensor_matrix_get_joined(void);
+/**@brief Get the maximum size of the sensor matrix **/
+int sensor_matrix_get_size(void);
 
 /** @} **/ //end defgroup
 
+
+#endif
+
Index: branches/encoders/code/lib/include/libwireless/wireless.h
===================================================================
--- branches/encoders/code/lib/include/libwireless/wireless.h	(revision 1344)
+++ branches/encoders/code/lib/include/libwireless/wireless.h	(revision 1345)
@@ -1,4 +1,29 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
  * @file wireless.h
  * @brief Contains definitions for the wireless library.
  *
@@ -6,12 +31,19 @@
  *
  * @author Brian Coltin, Colony Project, CMU Robotics Club
  **/
- 
+
+#ifndef WIRELESS_H
+#define WIRELESS_H
+
 //Note: If this is raised above 16, we will need to do
 //something about frame numbers for TX Status packets.
 /**
  * The maximum number of packet groups.
  **/
+//TODO: a PacketGroupHandler is at least 10 bytes (I don't know if function pointers are 2 bytes
+// or 4 bytes).  That means that in the c file, your array of packet groups is at least 160 bytes.
+// Normally that might be fine (the robot's avr chips have 4k SRAM), but austin's chip only has
+// 1k SRAM, so if this number can be reduced or if the size of the struct could be reduced, that would be a plus.
 #define WL_MAX_PACKET_GROUPS 16
 
 /**
@@ -20,12 +52,12 @@
  *
  * Contains functions and definitions for dealing with wireless functionality.<br><br>
  *
- * The wireless library provides a modular method for dealing with 
+ * The wireless library provides a modular method for dealing with
  * wireless packets, by allowing packet groups to be registered.
  * A packet group is a collection of packets which share a packet
- * group code. Each packet in the group also has a type. A packet 
+ * group code. Each packet in the group also has a type. A packet
  * group code and type are sent with each packet. When a packet
- * with a group code registered in the wireless library is 
+ * with a group code registered in the wireless library is
  * received, the corresponding event handler is called. The
  * event handler uses the packet type and other information
  * stored in the packet to respond.<br><br>
@@ -39,11 +71,14 @@
 
 /**
  * @struct PacketGroupHandler
- * A PacketGroupHandler represents a packet group, and is used to 
+ * A PacketGroupHandler represents a packet group, and is used to
  * register a packet group with the wireless library. It contains
  * handlers for various events which can occur related to a packet
  * group.
  **/
+//TODO: the order of member variables in this struct should be changed in case the compile packs the struct
+// In order to achieve the best packing, the variables should be listed in order of decreasing memory size.
+// Thus, pointers should be first, followed by int, followed by char.
 typedef struct
 {
 	/**
@@ -51,6 +86,8 @@
 	 * must be unique. The maximum number of packet groups
 	 * is defined by WL_MAX_PACKET_GROUPS.
 	 **/
+  //TODO: if this number must be less than or equal to WL_MAX_PACKET_GROUPS, don't you only need
+  // one byte for it and it can be made an unsigned char?
 	unsigned int groupCode;
 
 	/**
@@ -58,7 +95,7 @@
 	 * but in wl_do).
 	 **/
 	void (*timeout_handler) (void);
-	
+
 	/**
 	 * Called when a transmit status packet is received
 	 * from the XBee where the first four bits of the frame
@@ -69,7 +106,7 @@
 	 * we did not.
 	 **/
 	void (*handle_response) (int frame, int received);
-	
+
 	/**
 	 * Called when we receive a packet from this group.
 	 *
@@ -79,18 +116,17 @@
 	 * @param packet the packet received
 	 * @param length the length of the packet
 	 **/
-	void (*handle_receive) (char type, int source, unsigned char* packet,
-							int length);
-	
+	void (*handle_receive) (char type, int source, unsigned char* packet, int length);
+
 	/**
 	 * Called for any cleanup when the network is turned off.
 	 **/
 	void (*unregister) (void);
-	
+
 } PacketGroupHandler;
 
 /**@brief Initialize the wireless library **/
-void wl_init(void);
+int wl_init(void);
 /**@brief Uninitialize the wireless library **/
 void wl_terminate(void);
 /**@brief Perform wireless library functionality **/
@@ -101,28 +137,28 @@
 void wl_unregister_packet_group(PacketGroupHandler* h);
 
 /**@brief Send a packet to a specific robot in any PAN **/
-void wl_send_robot_to_robot_global_packet(char group, char type,
-		char* data, int len, int dest, char frame);
+int wl_send_robot_to_robot_global_packet(char group, char type, char* data, int len, int dest, char frame);
 /**@brief Send a packet to a specific robot in our PAN **/
-void wl_send_robot_to_robot_packet(char group, char type,
-		char* data, int len, int dest, char frame);
+int wl_send_robot_to_robot_packet(char group, char type, char* data, int len, int dest, char frame);
 /**@brief Send a packet to all robots **/
-void wl_send_global_packet(char group, char type,
-		char* data, int len, char frame);
+int wl_send_global_packet(char group, char type, char* data, int len, char frame);
 /**@brief Send a packet to all robots in our PAN **/
-void wl_send_pan_packet(char group, char type,
-		char* data, int len, char frame);
+void wl_send_pan_packet(char group, char type, char* data, int len, char frame);
 
 /**@brief Set the PAN we are using **/
-void wl_set_pan(int pan);
+int wl_set_pan(int pan);
 /**@brief Get the PAN we are using **/
 int wl_get_pan(void);
 /**@brief Set the channel we are using **/
-void wl_set_channel(int channel);
+int wl_set_channel(int channel);
 /**@brief Get the channel we are using **/
 int wl_get_channel(void);
 /**@brief Get the 16-bit address of the XBee module **/
-unsigned int wl_get_xbee_id(void);
+int wl_get_xbee_id(void);
+/**@brief Set the com port on a computer, undefined on the robot.**/
+void wl_set_com_port(char* port);
 
 /** @} **/ // end defgroup
 
+#endif
+
Index: branches/encoders/code/lib/include/libwireless/wl_token_ring.h
===================================================================
--- branches/encoders/code/lib/include/libwireless/wl_token_ring.h	(revision 1344)
+++ branches/encoders/code/lib/include/libwireless/wl_token_ring.h	(revision 1345)
@@ -1,4 +1,29 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
  * @file wl_token_ring.h
  * @brief Declarations for the token ring packet group
  * 
@@ -7,6 +32,9 @@
  * @author Brian Coltin, Colony Project, CMU Robotics Club
  **/
 
+#ifndef WL_TOKEN_RING_H
+#define WL_TOKEN_RING_H
+
 /**
  * @defgroup tokenring Token Ring
  * @brief Wireless library token ring implementation
@@ -19,19 +47,17 @@
  **/
 
 /**@brief Register the token ring group with the wireless library.**/
-void wl_token_ring_register(void);
+int wl_token_ring_register(void);
 /**@brief Unregister the token ring group with the wirelss library.**/
 void wl_token_ring_unregister(void);
 /**@brief Set the functions called to turn the bom on and off.**/
-void wl_token_ring_set_bom_functions(void (*on_function) (void), 
-		void (*off_function) (void), int (*max_bom_function) (void));
+void wl_token_ring_set_bom_functions(void (*on_function) (void), void (*off_function) (void),
+  int (*max_bom_function) (void));
 
 /**@brief Join the token ring **/
-void wl_token_ring_join(void);
+int wl_token_ring_join(void);
 /**@brief Leave the token ring **/
 void wl_token_ring_leave(void);
-/**@brief Request a BOM flash from the specified robot **/
-void wl_token_request(int robot);
 
 /**@brief Return the number of robots in the token ring **/
 int wl_token_get_robots_in_ring(void);
@@ -56,3 +82,4 @@
 
 /** @} **/ //end token ring group
 
+#endif
Index: branches/encoders/code/lib/include/libwireless/wl_defs.h
===================================================================
--- branches/encoders/code/lib/include/libwireless/wl_defs.h	(revision 1344)
+++ branches/encoders/code/lib/include/libwireless/wl_defs.h	(revision 1345)
@@ -1,8 +1,46 @@
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
+ * @file wl_defs.h
+ * @brief Definitions for Wireless
+ *
+ * Contains definitions for wireless packet groups, packet types,
+ * debugging information, etc.
+ *
+ * @author Brian Coltin, Colony Project, CMU Robotics Club
+ **/
+
+#ifndef WL_DEFS_H
+#define WL_DEFS_H
+
 //comment out this line if using a computer hooked up to an xbee
 //#define ROBOT
 
 //uncomment this line for debug information
-#define WL_DEBUG
+//#define WL_DEBUG
 
 // Packet Groups and Types
 
@@ -15,29 +53,21 @@
 #define WL_TOKEN_RING_GROUP 2
 
 #define WL_TOKEN_PASS 1
-#define WL_TOKEN_BOM_ON 2
-#define WL_TOKEN_INTERRUPT_REQUEST 3
-#define WL_TOKEN_INTERRUPT_PASS 4
-#define WL_TOKEN_JOIN 5
-#define WL_TOKEN_JOIN_ACCEPT 6
+#define WL_TOKEN_SENSOR_MATRIX 2
+#define WL_TOKEN_BOM_ON 3
+#define WL_TOKEN_JOIN 4
+#define WL_TOKEN_JOIN_ACCEPT 5
 
 // timing constants
+#ifndef FIREFLY
 #define BOM_DELAY 100
-#define DEATH_DELAY 3
+#else
+#define BOM_DELAY 200
+#endif
+
+#define DEATH_DELAY 4
 #define JOIN_DELAY 8
 
-// Recharging group
-#define WL_RECHARGE_GROUP 3
-
-#define WL_RECHARGE_POLL_STATIONS 1
-#define WL_RECHARGE_STATION_AVAILABLE 2
-#define WL_RECHARGE_REQUEST 3
-#define WL_RECHARGE_REQUEST_ACCEPT 4
-#define WL_RECHARGE_VERIFY 5
-#define WL_RECHARGE_CANCEL 6
-#define WL_RECHARGE_SEEKING 7
-#define WL_RECHARGE_DOCKED 8
-
 #ifdef WL_DEBUG
 
 #ifdef ROBOT
@@ -63,3 +93,5 @@
 
 #endif
 
+#endif
+
Index: branches/encoders/code/lib/include/libwireless/xbee.h
===================================================================
--- branches/encoders/code/lib/include/libwireless/xbee.h	(revision 1344)
+++ branches/encoders/code/lib/include/libwireless/xbee.h	(revision 1345)
@@ -1,4 +1,29 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
  * @file xbee.h
  * @brief Contains definitions for using the XBee
  *
@@ -10,7 +35,18 @@
  * @author Brian Coltin, Colony Project, CMU Robotics Club
  **/
 
+#ifndef XBEE_H
+#define XBEE_H
+
 /**
+ * The port to use the XBee from on the computer.
+ * Also, a backup port if the other is used.
+ **/
+#ifndef ROBOT
+#define XBEE_PORT_DEFAULT "/dev/ttyUSB1"
+#endif
+
+/**
  * @defgroup xbee XBee
  * @brief Interface with the XBee module
  *
@@ -38,24 +74,26 @@
 #define XBEE_RX 0x81
 
 /**@brief Initialize the XBee library **/
-void xbee_lib_init(void);
+int xbee_lib_init(void);
 /**@brief Uninitialize the XBee library **/
 void xbee_terminate(void);
 /**@brief Get a packet from the XBee **/
 int xbee_get_packet(unsigned char* packet);
 /**@brief Send a packet to the XBee **/
-void xbee_send_packet(char* packet, int len, int dest,
-	char options, char frame);
+int xbee_send_packet(char* packet, int len, int dest, char options, char frame);
 /**@brief Set the PAN ID for the XBee **/
-void xbee_set_pan_id(int id);
+int xbee_set_pan_id(int id);
 /**@brief Get the XBee's PAN ID **/
 unsigned int xbee_get_pan_id(void);
 /**@brief Set the channel the XBee is currently using **/
-void xbee_set_channel(int channel);
+int xbee_set_channel(int channel);
 /**@brief Get the channel the XBee is currently using **/
 int xbee_get_channel(void);
 /**@brief Get the XBee's 16-bit address **/
 unsigned int xbee_get_address(void);
+/**@brief Set the com port on a computer, undefined on the robot**/
+void xbee_set_com_port(char* port);
 
 /**@}**/ //end defgroup
 
+#endif
Index: branches/encoders/code/lib/include/libwireless/wl_error_group.h
===================================================================
--- branches/encoders/code/lib/include/libwireless/wl_error_group.h	(revision 1344)
+++ branches/encoders/code/lib/include/libwireless/wl_error_group.h	(revision 1345)
@@ -1,5 +1,42 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
  * @file wl_error_group.h
+ * @brief Error Packets
+ *
+ * A packet group for sending error packets.
+ *
+ * @author Brian Coltin, Colony Project, CMU Robotics Club
+ **/
+
+#ifndef WL_ERROR_GROUP_H
+#define WL_ERROR_GROUP_H
+
+/**
+ * @file wl_error_group.h
  * @brief A packet group for error messages.
  *
  * A packet group for sending and receiving error
@@ -26,3 +63,4 @@
 
 /** @} **/ // end defgroup
 
+#endif
Index: branches/encoders/code/lib/include/libdragonfly/spi.h
===================================================================
--- branches/encoders/code/lib/include/libdragonfly/spi.h	(revision 1344)
+++ branches/encoders/code/lib/include/libdragonfly/spi.h	(revision 1345)
@@ -4,6 +4,11 @@
  * @author Colony Project, CMU Robotics Club
  **/
 
+/**
+ * @addtogroup spi
+ * @{
+ **/
+
 #ifndef __SPI_H__
 #define __SPI_H__
 
@@ -21,7 +26,21 @@
 typedef void (*spi_fun_recv_t)(char);
 typedef void (*spi_fun_recv_complete_t)(void);
 
+/** 
+* @brief Initialize SPI
+* 
+* @param spi_fun_recv_t The function that handles SPI data, byte for byte.
+* @param spi_fun_recv_complete_t  Called on a completed transmission - typically for cleaning up.
+*/
 void spi_init (spi_fun_recv_t, spi_fun_recv_complete_t);
+
+/** 
+* @brief Initialize SPI transfer.
+* 
+* @param char The number of bytes to transfer.
+*/
 void spi_transfer (char);
 
+/**@}**/ //end group
+
 #endif
